//---------------------------------------------------------------------------
// TDcjCustomDlg Abstract Class
// Copyright (c) 1998 Michael Trier.  All Rights Reserved.
// See source file for restrictions.
//---------------------------------------------------------------------------
#ifndef DcjCustomDlgH
#define DcjCustomDlgH
//---------------------------------------------------------------------------
#include "Dcjdef.h"
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
// forward declarations
class PACKAGE TDcjCustomDlg;
//---------------------------------------------------------------------------
// TDcjDialogForm Declaration
//---------------------------------------------------------------------------
class TDcjDialogForm : public Forms::TForm
{
private:

public:
	/* TForm.Create */ __fastcall virtual TDcjDialogForm(
      Classes::TComponent* AOwner) : Forms::TForm(AOwner) { }
	/* TForm.CreateNew */ __fastcall TDcjDialogForm(Classes::TComponent* AOwner,
      int Dummy) : Forms::TForm(AOwner, Dummy) { }
	/* TForm.Destroy */ __fastcall virtual ~TDcjDialogForm(void) { }

  /* TWinControl.CreateParented */ __fastcall TDcjDialogForm(HWND ParentWindow)
      : Forms::TForm(ParentWindow) { }

  void __fastcall HelpButtonClick(System::TObject* Sender);
};
//---------------------------------------------------------------------------
// TDcjCustomDlg Declaration
//---------------------------------------------------------------------------
class PACKAGE TDcjCustomDlg : public TComponent
{
private:
  AnsiString FCaption;
  TFont *FFont;
  AnsiString FText;
  TModalResult FModalResult;
  THelpContext FHelpContext;

protected:
  // protected member helper functions
  virtual TDcjDialogForm* __fastcall CreateDcjDialog(void) = 0;
  virtual void __fastcall SetFont(TFont *Value);
  virtual void __fastcall SetModalResult(TModalResult Value);
  virtual AnsiString __fastcall GetVersion(void) = 0;
  virtual void __fastcall SetVersion(AnsiString Value);

  __property TModalResult ModalResult = {read=FModalResult, write=SetModalResult};
  __property AnsiString Caption = {read=FCaption, write=FCaption};
  __property TFont *Font = {read=FFont, write=SetFont};
  __property AnsiString Text = {read=FText, write=FText};
  __property THelpContext HelpContext = {read=FHelpContext,
      write=FHelpContext, default=0};
  __property AnsiString Version = {read=GetVersion, write=SetVersion};

public:
  __fastcall TDcjCustomDlg(TComponent* Owner);
  __fastcall ~TDcjCustomDlg(void);

  // overriden public member functions
  virtual void __fastcall Assign(TPersistent *Source);

  // works with the component editor to return preview results
  virtual AnsiString __fastcall PreviewResults(void) { };

  // public member functions
  virtual bool __fastcall Execute(void);
};
//---------------------------------------------------------------------------
#endif
