//---------------------------------------------------------------------------
// TDcjRootKey Class
//
// Copyright  1998, Michael Trier.  All Rights Reserved.
// Email: mtrier@pobox.com  Website: www.dcjournal.com
//---------------------------------------------------------------------------
// This component and any associated property editors and/or component editors
// can be freely used and distributed, provided all source code files are not
// modified in any way and there is no charge for it other than nominal shipping
// and handling fees.  Please contact me directly if you desire to modify the
// terms of this agreement.
//---------------------------------------------------------------------------
// Please note:  This source code is provided as a teaching tool. If you
// decide that you want to use whole routines or modules directly in an
// application that you are creating, please give credit where it is due.
// Given the above, keep in mind that these applications are copyright
// property of Michael Trier.
//---------------------------------------------------------------------------
// Date last modified: $Date: 1998/11/15 15:14:46 $
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// TDcjRootKey $Revision: 0.52 $
//---------------------------------------------------------------------------
// Revision History:
// $Log: DcjRootKey.cpp,v $
// Revision 0.52  1998/11/15 15:14:46  michael
// - Added Set method for RootKeyAsString and RootKeyAsHKEYString
//
// Revision 0.51  1998/11/14 15:25:35  michael
// - Move constructor from inline to the implementation section
// - Minor other changes
//
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DcjRootKey.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// TDcjRootKey Implementation
//---------------------------------------------------------------------------
__fastcall TDcjRootKey::TDcjRootKey(TDcjRootKeyEnum Root)
{
  FRootKey = Root;
}
//---------------------------------------------------------------------------
HKEY __fastcall TDcjRootKey::GetRootKeyAsHKEY(void)
{
  // return the RootKey value as an HKEY value
  HKEY hkeys[5] = {NULL, HKEY_CLASSES_ROOT, HKEY_CURRENT_USER,
      HKEY_LOCAL_MACHINE, HKEY_USERS};

  return hkeys[RootKey];
}
//---------------------------------------------------------------------------
void __fastcall TDcjRootKey::SetRootKeyAsHKEY(HKEY Value)
{
  // set the RootKey value from an HKEY value
  if( Value != RootKeyAsHKEY ) {
    HKEY hkeys[5] = {NULL, HKEY_CLASSES_ROOT, HKEY_CURRENT_USER,
        HKEY_LOCAL_MACHINE, HKEY_USERS};

    for( int i = 0; i < 5; i++ )
      if( hkeys[i] == Value ) {
        FRootKey = i;
        break;
      }
  }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDcjRootKey::GetRootKeyAsString(void)
{
  // return the RootKey as a string
  AnsiString skeys[5] = {"rkNone", "rkClassesRoot", "rkCurrentUser",
      "rkLocalMachine", "rkUsers"};
  return skeys[RootKey];
}
//---------------------------------------------------------------------------
void __fastcall TDcjRootKey::SetRootKeyAsString(AnsiString Value)
{
  // set the root key by a rootkey string
  // note: probably not very efficient, but it works
  if( Value != RootKeyAsString ) {
    AnsiString skeys[5] = {"rkNone", "rkClassesRoot", "rkCurrentUser",
        "rkLocalMachine", "rkUsers"};

    for( int i = 0; i < 5; i++ )
      if( skeys[i] == Value ) {
        FRootKey = i;
        break;
      }
  }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDcjRootKey::GetRootKeyAsHKEYString(void)
{
  // return the RootKey as a string
  AnsiString skeys[5] = {"My Computer", "HKEY_CLASSES_ROOT", "HKEY_CURRENT_USER",
      "HKEY_LOCAL_MACHINE", "HKEY_USERS"};
  return skeys[RootKey];
}
//---------------------------------------------------------------------------
void __fastcall TDcjRootKey::SetRootKeyAsHKEYString(AnsiString Value)
{
  // set the root key by an HKEY string
  // note: probably not very efficient, but it works
  if( Value != RootKeyAsHKEYString ) {
    AnsiString skeys[5] = {"My Computer", "HKEY_CLASSES_ROOT", "HKEY_CURRENT_USER",
        "HKEY_LOCAL_MACHINE", "HKEY_USERS"};

    for( int i = 0; i < 5; i++ )
      if( skeys[i] == Value ) {
        FRootKey = i;
        break;
      }
  }
}
//---------------------------------------------------------------------------

